diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 9d22950d79b..14737295831 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -2772,32 +2278,32 @@ strongly_connected_components::to_json () const
    SCC algorithm.  */
 
 void
-strongly_connected_components::strong_connect (unsigned index)
+strongly_connected_components::strong_connect (unsigned id,
+					       logger *logger)
 {
-  supernode *v_snode = m_sg.get_node_by_index (index);
+  supernode *v_snode = m_sg.m_nodes[id]; // FIXME: get_node_by_id (id);
+  if (!v_snode)
+    return;
 
   /* Set the depth index for v to the smallest unused index.  */
-  per_node_data *v = &m_per_node[index];
-  v->m_index = index;
-  v->m_lowlink = index;
-  m_stack.safe_push (index);
+  per_node_data *v = &m_per_node[id];
+  v->m_id = id;
+  v->m_lowlink = id;
+  m_stack.safe_push (id);
   v->m_on_stack = true;
-  index++;
+  id++;
 
   /* Consider successors of v.  */
   unsigned i;
   superedge *sedge;
   FOR_EACH_VEC_ELT (v_snode->m_succs, i, sedge)
     {
-      if (sedge->get_kind () != SUPEREDGE_CFG_EDGE
-	  && sedge->get_kind () != SUPEREDGE_INTRAPROCEDURAL_CALL)
-	continue;
       supernode *w_snode = sedge->m_dest;
-      per_node_data *w = &m_per_node[w_snode->m_index];
-      if (w->m_index == -1)
+      per_node_data *w = &m_per_node[w_snode->m_id];
+      if (w->m_id == -1)
 	{
 	  /* Successor w has not yet been visited; recurse on it.  */
-	  strong_connect (w_snode->m_index);
+	  strong_connect (w_snode->m_id, logger);
 	  v->m_lowlink = MIN (v->m_lowlink, w->m_lowlink);
 	}
       else if (w->m_on_stack)
@@ -2805,19 +2311,23 @@ strongly_connected_components::strong_connect (unsigned index)
 	  /* Successor w is in stack S and hence in the current SCC
 	     If w is not on stack, then (v, w) is a cross-edge in the DFS
 	     tree and must be ignored.  */
-	  v->m_lowlink = MIN (v->m_lowlink, w->m_index);
+	  v->m_lowlink = MIN (v->m_lowlink, w->m_id);
 	}
     }
 
   /* If v is a root node, pop the stack and generate an SCC.  */
 
-  if (v->m_lowlink == v->m_index)
+  if (v->m_lowlink == v->m_id)
     {
+      if (logger)
+	logger->log ("got SCC root node: SN %i", v->m_id);
       per_node_data *w;
       do {
-	int idx = m_stack.pop ();
-	w = &m_per_node[idx];
+	int id = m_stack.pop ();
+	w = &m_per_node[id];
 	w->m_on_stack = false;
+	if (logger)
+	  logger->log ("  popping SN %i", w->m_id);
       } while (w != v);
     }
 }
@@ -2940,18 +2450,13 @@ worklist::key_t::cmp (const worklist::key_t &ka, const worklist::key_t &kb)
     return 1;
   /* Neither are nullptr.  */
   gcc_assert (snode_a && snode_b);
-  if (snode_a->m_index != snode_b->m_index)
-    return snode_a->m_index - snode_b->m_index;
+  if (snode_a->m_bb->index != snode_b->m_bb->index)
+    return snode_a->m_bb->index - snode_b->m_bb->index;
+  if (snode_a->m_id != snode_b->m_id)
+    return snode_a->m_id - snode_b->m_id;
 
   gcc_assert (snode_a == snode_b);
 
-  /* Order within supernode via program point.  */
-  int within_snode_cmp
-    = function_point::cmp_within_supernode (point_a.get_function_point (),
-					    point_b.get_function_point ());
-  if (within_snode_cmp)
-    return within_snode_cmp;
-
   /* Otherwise, we ought to have the same program_point.  */
   gcc_assert (point_a == point_b);
 
@@ -3006,15 +2511,12 @@ exploded_graph::exploded_graph (const supergraph &sg, logger *logger,
   m_purge_map (purge_map),
   m_plan (plan),
   m_diagnostic_manager (logger, ext_state.get_engine (), verbosity),
-  m_global_stats (m_sg.num_nodes ()),
-  m_functionless_stats (m_sg.num_nodes ()),
-  m_PK_AFTER_SUPERNODE_per_snode (m_sg.num_nodes ())
+  m_global_stats (m_sg.m_nodes.length ()),
+  m_functionless_stats (m_sg.m_nodes.length ())
 {
   m_origin = get_or_create_node
     (program_point::origin (*ext_state.get_model_manager ()),
      program_state (ext_state), nullptr);
-  for (int i = 0; i < m_sg.num_nodes (); i++)
-    m_PK_AFTER_SUPERNODE_per_snode.quick_push (i);
 }
 
 /* exploded_graph's dtor.  */
@@ -3121,16 +2623,19 @@ public:
     pp_string (pp, "call to tainted_args function");
   };
 
-  bool update_model (region_model *,
-		     const exploded_edge *,
-		     region_model_context *) const final override
+  bool update_model (region_model *model,
+		     const exploded_edge *eedge,
+		     region_model_context *ctxt) const final override
   {
-    /* No-op.  */
+    function *fun = eedge->m_dest->get_function ();
+    gcc_assert (fun);
+    model->push_frame (*fun, nullptr, nullptr, ctxt);
     return true;
   }
 
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &) const final override
+			   const exploded_edge &,
+			   pending_diagnostic &) const final override
   {
     emission_path->add_event
       (std::make_unique<tainted_args_function_custom_event>
@@ -3231,6 +2736,14 @@ exploded_graph::get_or_create_node (const program_point &point,
       return nullptr;
     }
 
+  if (point.get_call_string ().calc_recursion_depth ()
+      > param_analyzer_max_recursion_depth)
+    {
+      if (logger)
+	logger->log ("rejecting node: recursion limit exceeded");
+      return nullptr;
+    }
+
   auto_cfun sentinel (point.get_function ());
 
   state.validate (get_ext_state ());
@@ -3280,7 +2793,7 @@ exploded_graph::get_or_create_node (const program_point &point,
     = get_or_create_per_program_point_data (point);
 
   /* Consider merging state with another enode at this program_point.  */
-  if (flag_analyzer_state_merge)
+  if (flag_analyzer_state_merge && point.state_merge_at_p ())
     {
       exploded_node *existing_enode;
       unsigned i;
@@ -3355,13 +2868,9 @@ exploded_graph::get_or_create_node (const program_point &point,
   /* Update per-program_point data.  */
   per_point_data->m_enodes.safe_push (node);
 
-  const enum point_kind node_pk = node->get_point ().get_kind ();
-  m_global_stats.m_num_nodes[node_pk]++;
-  per_fn_stats->m_num_nodes[node_pk]++;
-  per_cs_stats->m_num_nodes[node_pk]++;
-
-  if (node_pk == PK_AFTER_SUPERNODE)
-    m_PK_AFTER_SUPERNODE_per_snode[point.get_supernode ()->m_index]++;
+  m_global_stats.m_num_nodes++;
+  per_fn_stats->m_num_nodes++;
+  per_cs_stats->m_num_nodes++;
 
   if (logger)
     {
@@ -3373,8 +2882,8 @@ exploded_graph::get_or_create_node (const program_point &point,
       point.print (pp, f);
       logger->end_log_line ();
       logger->start_log_line ();
-      pp_string (pp, "pruned_state: ");
-      pruned_state.dump_to_pp (m_ext_state, true, false, pp);
+      pp_string (pp, "state: ");
+      ps.get_state ().dump_to_pp (m_ext_state, true, false, pp);
       logger->end_log_line ();
     }
 
@@ -3443,7 +2952,7 @@ exploded_graph::get_or_create_per_call_string_data (const call_string &cs)
   if (per_call_string_data **slot = m_per_call_string_data.get (&cs))
     return *slot;
 
-  per_call_string_data *data = new per_call_string_data (cs, m_sg.num_nodes ());
+  per_call_string_data *data = new per_call_string_data (cs, m_sg.m_nodes.length ());
   m_per_call_string_data.put (&data->m_key,
 			      data);
   return data;
@@ -3571,16 +3080,18 @@ public:
     pp_string (pp, "call to tainted field");
   };
 
-  bool update_model (region_model *,
-		     const exploded_edge *,
+  bool update_model (region_model *model,
+		     const exploded_edge *eedge,
 		     region_model_context *) const final override
   {
-    /* No-op.  */
+    model->push_frame (*eedge->m_dest->get_function (),
+		       nullptr, nullptr, nullptr);
     return true;
   }
 
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &) const final override
+			   const exploded_edge &,
+			   pending_diagnostic &) const final override
   {
     /* Show the field in the struct declaration, e.g.
        "(1) field 'store' is marked with '__attribute__((tainted_args))'"  */
@@ -3745,16 +3256,15 @@ exploded_graph::process_worklist ()
     {
       exploded_node *node = m_worklist.take_next ();
       gcc_assert (node->get_status () == exploded_node::status::worklist);
-      gcc_assert (node->m_succs.length () == 0
-		  || node == m_origin);
 
       if (logger)
 	logger->log ("next to process: EN: %i", node->m_index);
 
-      /* If we have a run of nodes that are before-supernode, try merging and
+      /* If we have a run of nodes at the same point, try merging and
 	 processing them together, rather than pairwise or individually.  */
-      if (flag_analyzer_state_merge && node != m_origin)
-	if (maybe_process_run_of_before_supernode_enodes (node))
+      if (flag_analyzer_state_merge
+	  && node->get_point ().state_merge_at_p ())
+	if (maybe_process_run_of_enodes (node))
 	  goto handle_limit;
 
       /* Avoid exponential explosions of nodes by attempting to merge
@@ -3765,9 +3275,6 @@ exploded_graph::process_worklist ()
 	  {
 	    gcc_assert (node_2->get_status ()
 			== exploded_node::status::worklist);
-	    gcc_assert (node->m_succs.length () == 0);
-	    gcc_assert (node_2->m_succs.length () == 0);
-
 	    gcc_assert (node != node_2);
 
 	    if (logger)
@@ -3890,45 +3397,37 @@ exploded_graph::process_worklist ()
     handle_limit:
       /* Impose a hard limit on the number of exploded nodes, to ensure
 	 that the analysis terminates in the face of pathological state
-	 explosion (or bugs).
-
-	 Specifically, the limit is on the number of PK_AFTER_SUPERNODE
-	 exploded nodes, looking at supernode exit events.
-
-	 We use exit rather than entry since there can be multiple
-	 entry ENs, one per phi; the number of PK_AFTER_SUPERNODE ought
-	 to be equivalent to the number of supernodes multiplied by the
-	 number of states.  */
-      const int limit = m_sg.num_nodes () * param_analyzer_bb_explosion_factor;
-      if (m_global_stats.m_num_nodes[PK_AFTER_SUPERNODE] > limit)
-	{
-	  if (logger)
-	    logger->log ("bailing out; too many nodes");
-	  warning_at (node->get_point ().get_location (),
-		      OPT_Wanalyzer_too_complex,
-		      "analysis bailed out early"
-		      " (%i 'after-snode' enodes; %i enodes)",
-		      m_global_stats.m_num_nodes[PK_AFTER_SUPERNODE],
-		      m_nodes.length ());
-	  return;
-	}
+	 explosion (or bugs).  */
+      if (const int limit
+	    = m_sg.num_nodes () * param_analyzer_bb_explosion_factor)
+	if (m_global_stats.m_num_nodes > limit)
+	  {
+	    if (logger)
+	      logger->log ("bailing out; too many nodes");
+	    warning_at (node->get_point ().get_location (),
+			OPT_Wanalyzer_too_complex,
+			"analysis bailed out early"
+			" (%i enodes)",
+			m_nodes.length ());
+	    return;
+	  }
     }
 }
 
 /* Attempt to process a consecutive run of sufficiently-similar nodes in
-   the worklist at a CFG join-point (having already popped ENODE from the
-   head of the worklist).
+   the worklist at a point flagged with state_merge_at_p (having already
+   popped ENODE from the head of the worklist).
 
-   If ENODE's point is of the form (before-supernode, SNODE) and the next
-   nodes in the worklist are a consecutive run of enodes of the same form,
-   for the same supernode as ENODE (but potentially from different in-edges),
+   If we have a consecutive run of enodes in the worklist all of which have
+   a single out-edge where all these out-edges are supports_bulk_merge_p and
+   all have the same successor snode and call string, then
    process them all together, setting their status to status::bulk_merged,
    and return true.
    Otherwise, return false, in which case ENODE must be processed in the
    normal way.
 
    When processing them all together, generate successor states based
-   on phi nodes for the appropriate CFG edges, and then attempt to merge
+   on the edge op update_state_for_bulk_merger, and then attempt to merge
    these states into a minimal set of merged successor states, partitioning
    the inputs by merged successor state.
 
@@ -3945,7 +3444,7 @@ exploded_graph::process_worklist ()
 
 bool
 exploded_graph::
-maybe_process_run_of_before_supernode_enodes (exploded_node *enode)
+maybe_process_run_of_enodes (exploded_node *enode)
 {
   /* A struct for tracking per-input state.  */
   struct item
@@ -3962,20 +3461,29 @@ maybe_process_run_of_before_supernode_enodes (exploded_node *enode)
   };
 
   gcc_assert (enode->get_status () == exploded_node::status::worklist);
+#if 0
   gcc_assert (enode->m_succs.length () == 0);
+#endif
 
-  const program_point &point = enode->get_point ();
+  const program_point &src_point = enode->get_point ();
+  const supernode *src_snode = src_point.get_supernode ();
 
-  if (point.get_kind () != PK_BEFORE_SUPERNODE)
+  logger * const logger = get_logger ();
+  LOG_SCOPE (logger);
+
+  if (src_snode->m_succs.length () != 1)
     return false;
 
-  const supernode *snode = point.get_supernode ();
+  auto sedge = src_snode->m_succs[0];
 
-  logger * const logger = get_logger ();
-  LOG_SCOPE (logger);
+  if (!sedge->supports_bulk_merge_p ())
+    return false;
+
+  const supernode *dst_snode = src_snode->m_succs[0]->m_dest;
 
-  /* Find a run of enodes in the worklist that are before the same supernode,
-     but potentially from different in-edges.  */
+  /* Find a run of enodes in the worklist that all have single out-sedges
+     go to the same supernode, all of which are bulk-mergeable (i.e. have
+     a simple single intraprocedural outcome).  */
   auto_vec <exploded_node *> enodes;
   enodes.safe_push (enode);
   while (exploded_node *enode_2 = m_worklist.peek_next ())
@@ -3985,16 +3493,20 @@ maybe_process_run_of_before_supernode_enodes (exploded_node *enode)
       gcc_assert (enode_2->m_succs.length () == 0);
 
       const program_point &point_2 = enode_2->get_point ();
+      const supernode *src_snode_2 = point_2.get_supernode ();
 
-      if (point_2.get_kind () == PK_BEFORE_SUPERNODE
-	  && point_2.get_supernode () == snode
-	  && &point_2.get_call_string () == &point.get_call_string ())
-	{
-	  enodes.safe_push (enode_2);
-	  m_worklist.take_next ();
-	}
-      else
+      if (src_snode_2->m_succs.length () != 1)
+	break;
+      auto sedge_2 = src_snode_2->m_succs[0];
+      if (sedge_2->m_dest != dst_snode)
+	break;
+      if (&point_2.get_call_string () != &src_point.get_call_string ())
 	break;
+      if (!sedge_2->supports_bulk_merge_p ())
+	break;
+
+      enodes.safe_push (enode_2);
+      m_worklist.take_next ();
     }
 
   /* If the only node is ENODE, then give up.  */
@@ -4002,12 +3514,13 @@ maybe_process_run_of_before_supernode_enodes (exploded_node *enode)
     return false;
 
   if (logger)
-    logger->log ("got run of %i enodes for SN: %i",
-		 enodes.length (), snode->m_index);
+    logger->log ("got run of %i bulk-mergable enodes going to SN: %i",
+		 enodes.length (), dst_snode->m_id);
 
-  /* All of these enodes have a shared successor point (even if they
-     were for different in-edges).  */
-  program_point next_point (point.get_next ());
+  /* All of these enodes have a shared intraprocedural successor point
+     (even if they were for different in-edges).  */
+  program_point next_point (sedge->m_dest,
+			    src_point.get_call_string ());
 
   /* Calculate the successor state for each enode in enodes.  */
   auto_delete_vec<item> items (enodes.length ());
@@ -4020,19 +3533,10 @@ maybe_process_run_of_before_supernode_enodes (exploded_node *enode)
       const program_state &state = iter_enode->get_state ();
       program_state *next_state = &it->m_processed_state;
       next_state->validate (m_ext_state);
-      const program_point &iter_point = iter_enode->get_point ();
-      if (const superedge *iter_sedge = iter_point.get_from_edge ())
-	{
-	  uncertainty_t uncertainty;
-	  impl_region_model_context ctxt (*this, iter_enode,
-					  &state, next_state,
-					  &uncertainty, nullptr, nullptr);
-	  const cfg_superedge *last_cfg_superedge
-	    = iter_sedge->dyn_cast_cfg_superedge ();
-	  if (last_cfg_superedge)
-	    next_state->m_region_model->update_for_phis
-	      (snode, last_cfg_superedge, &ctxt);
-	}
+      gcc_assert (iter_enode->get_supernode ()->m_succs.length () == 1);
+      const superedge *iter_sedge = iter_enode->get_supernode ()->m_succs[0];
+      if (auto op = iter_sedge->get_op ())
+	op->update_state_for_bulk_merger (state, *next_state);
       next_state->validate (m_ext_state);
     }
 
@@ -4106,275 +3610,24 @@ maybe_process_run_of_before_supernode_enodes (exploded_node *enode)
     {
       exploded_node *next = next_enodes[it->m_merger_idx];
       if (next)
-	add_edge (it->m_input_enode, next, nullptr,
-		  false); /* no "work" is done during merger.  */
+	{
+	  gcc_assert (it->m_input_enode->get_supernode ()->m_succs.length ()
+		      == 1);
+	  const superedge *sedge
+	    = it->m_input_enode->get_supernode ()->m_succs[0];
+	  add_edge (it->m_input_enode, next, sedge,
+		    false); /* no "work" is done during merger.  */
+	}
       it->m_input_enode->set_status (exploded_node::status::bulk_merged);
     }
 
   if (logger)
     logger->log ("merged %i in-enodes into %i out-enode(s) at SN: %i",
-		 items.length (), merged_states.length (), snode->m_index);
+		 items.length (), merged_states.length (), dst_snode->m_id);
 
   return true;
 }
 
-/* Return true if STMT must appear at the start of its exploded node, and
-   thus we can't consolidate its effects within a run of other statements,
-   where PREV_STMT was the previous statement.  */
-
-static bool
-stmt_requires_new_enode_p (const gimple *stmt,
-			   const gimple *prev_stmt)
-{
-  if (const gcall *call_stmt = dyn_cast <const gcall *> (stmt))
-    {
-      const gcall &call = *call_stmt;
-      /* Stop consolidating at calls to
-	 "__analyzer_dump_exploded_nodes", so they always appear at the
-	 start of an exploded_node.  */
-      if (is_special_named_call_p (call, "__analyzer_dump_exploded_nodes",
-				   1))
-	return true;
-
-      /* sm-signal.cc injects an additional custom eedge at "signal" calls
-	 from the registration enode to the handler enode, separate from the
-	 regular next state, which defeats the "detect state change" logic
-	 in process_node.  Work around this via special-casing, to ensure
-	 we split the enode immediately before any "signal" call.  */
-      if (is_special_named_call_p (call, "signal", 2, true))
-	return true;
-    }
-
-  /* If we had a PREV_STMT with an unknown location, and this stmt
-     has a known location, then if a state change happens here, it
-     could be consolidated into PREV_STMT, giving us an event with
-     no location.  Ensure that STMT gets its own exploded_node to
-     avoid this.  */
-  if (get_pure_location (prev_stmt->location) == UNKNOWN_LOCATION
-      && get_pure_location (stmt->location) != UNKNOWN_LOCATION)
-    return true;
-
-  return false;
-}
-
-/* Return true if OLD_STATE and NEW_STATE are sufficiently different that
-   we should split enodes and create an exploded_edge separating them
-   (which makes it easier to identify state changes of intereset when
-   constructing checker_paths).  */
-
-static bool
-state_change_requires_new_enode_p (const program_state &old_state,
-				   const program_state &new_state)
-{
-  /* Changes in dynamic extents signify creations of heap/alloca regions
-     and resizings of heap regions; likely to be of interest in
-     diagnostic paths.  */
-  if (old_state.m_region_model->get_dynamic_extents ()
-      != new_state.m_region_model->get_dynamic_extents ())
-    return true;
-
-  /* Changes in sm-state are of interest.  */
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (old_state.m_checker_states, sm_idx, smap)
-    {
-      const sm_state_map *old_smap = old_state.m_checker_states[sm_idx];
-      const sm_state_map *new_smap = new_state.m_checker_states[sm_idx];
-      if (*old_smap != *new_smap)
-	return true;
-    }
-
-  return false;
-}
-
-/* Create enodes and eedges for the function calls that doesn't have an
-   underlying call superedge.
-
-   Such case occurs when GCC's middle end didn't know which function to
-   call but the analyzer does (with the help of current state).
-
-   Some example such calls are dynamically dispatched calls to virtual
-   functions or calls that happen via function pointer.  */
-
-bool
-exploded_graph::maybe_create_dynamic_call (const gcall &call,
-					   tree fn_decl,
-					   exploded_node *node,
-					   program_state next_state,
-					   program_point &next_point,
-					   uncertainty_t *uncertainty,
-					   logger *logger)
-{
-  LOG_FUNC (logger);
-
-  const program_point *this_point = &node->get_point ();
-  function *fun = DECL_STRUCT_FUNCTION (fn_decl);
-  if (fun)
-    {
-      const supergraph &sg = this->get_supergraph ();
-      supernode *sn_entry = sg.get_node_for_function_entry (*fun);
-      supernode *sn_exit = sg.get_node_for_function_exit (*fun);
-
-      program_point new_point
-	= program_point::before_supernode (sn_entry,
-					   nullptr,
-					   this_point->get_call_string ());
-
-      new_point.push_to_call_stack (sn_exit,
-				    next_point.get_supernode());
-
-      /* Impose a maximum recursion depth and don't analyze paths
-	 that exceed it further.
-	 This is something of a blunt workaround, but it only
-	 applies to recursion (and mutual recursion), not to
-	 general call stacks.  */
-      if (new_point.get_call_string ().calc_recursion_depth ()
-	  > param_analyzer_max_recursion_depth)
-      {
-	if (logger)
-	  logger->log ("rejecting call edge: recursion limit exceeded");
-	return false;
-      }
-
-      next_state.push_call (*this, node, call, uncertainty);
-
-      if (next_state.m_valid)
-	{
-	  if (logger)
-	    logger->log ("Discovered call to %s [SN: %i -> SN: %i]",
-			 function_name(fun),
-			 this_point->get_supernode ()->m_index,
-			 sn_entry->m_index);
-
-	  exploded_node *enode = get_or_create_node (new_point,
-						     next_state,
-						     node);
-	  if (enode)
-	    add_edge (node,enode, nullptr,
-		      false, /* No work is done by the call itself.  */
-		      std::make_unique<dynamic_call_info_t> (call));
-	  return true;
-	}
-    }
-  return false;
-}
-
-/* Subclass of path_context for use within exploded_graph::process_node,
-   so that we can split states e.g. at "realloc" calls.  */
-
-class impl_path_context : public path_context
-{
-public:
-  impl_path_context (const program_state *cur_state,
-		     logger *logger)
-  : m_cur_state (cur_state),
-    m_logger (logger),
-    m_terminate_path (false)
-  {
-  }
-
-  bool bifurcation_p () const
-  {
-    return m_custom_eedge_infos.length () > 0;
-  }
-
-  const program_state &get_state_at_bifurcation () const
-  {
-    gcc_assert (m_state_at_bifurcation);
-    return *m_state_at_bifurcation;
-  }
-
-  void
-  bifurcate (std::unique_ptr<custom_edge_info> info) final override
-  {
-    if (m_logger)
-      m_logger->log ("bifurcating path");
-
-    if (m_state_at_bifurcation)
-      /* Verify that the state at bifurcation is consistent when we
-	 split into multiple out-edges.  */
-      gcc_assert (*m_state_at_bifurcation == *m_cur_state);
-    else
-      /* Take a copy of the cur_state at the moment when bifurcation
-	 happens.  */
-      m_state_at_bifurcation
-	= std::unique_ptr<program_state> (new program_state (*m_cur_state));
-
-    /* Take ownership of INFO.  */
-    m_custom_eedge_infos.safe_push (info.release ());
-  }
-
-  void terminate_path () final override
-  {
-    if (m_logger)
-      m_logger->log ("terminating path");
-    m_terminate_path = true;
-  }
-
-  bool terminate_path_p () const final override
-  {
-    return m_terminate_path;
-  }
-
-  const vec<custom_edge_info *> & get_custom_eedge_infos ()
-  {
-    return m_custom_eedge_infos;
-  }
-
-private:
-  const program_state *m_cur_state;
-
-  logger *m_logger;
-
-  /* Lazily-created copy of the state before the split.  */
-  std::unique_ptr<program_state> m_state_at_bifurcation;
-
-  auto_vec <custom_edge_info *> m_custom_eedge_infos;
-
-  bool m_terminate_path;
-};
-
-/* A subclass of pending_diagnostic for complaining about jumps through NULL
-   function pointers.  */
-
-class jump_through_null : public pending_diagnostic_subclass<jump_through_null>
-{
-public:
-  jump_through_null (const gcall &call)
-  : m_call (call)
-  {}
-
-  const char *get_kind () const final override
-  {
-    return "jump_through_null";
-  }
-
-  bool operator== (const jump_through_null &other) const
-  {
-    return &m_call == &other.m_call;
-  }
-
-  int get_controlling_option () const final override
-  {
-    return OPT_Wanalyzer_jump_through_null;
-  }
-
-  bool emit (diagnostic_emission_context &ctxt) final override
-  {
-    return ctxt.warn ("jump through null pointer");
-  }
-
-  bool describe_final_event (pretty_printer &pp,
-			     const evdesc::final_event &) final override
-  {
-    pp_string (&pp, "jump through null pointer here");
-    return true;
-  }
-
-private:
-  const gcall &m_call;
-};
-
 /* The core of exploded_graph::process_worklist (the main analysis loop),
    handling one node in the worklist.
 
@@ -4396,9 +3649,8 @@ exploded_graph::process_node (exploded_node *node)
   /* Update cfun and input_location in case of an ICE: make it easier to
      track down which source construct we're failing to handle.  */
   auto_cfun sentinel (node->get_function ());
-  const gimple *stmt = point.get_stmt ();
-  if (stmt)
-    input_location = stmt->location;
+
+  input_location = node->get_location ();
 
   const program_state &state = node->get_state ();
   if (logger)
